
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

int main(int argc, char **argv) {
	struct stat infile_s;
	FILE *infile;
	char *buf;
	char *image_start;
	FILE *image;
	char *image_buf;
	int image_buf_index;
	FILE *outfile;
	int i;

	if(argc!=8) {
		printf("usage: %s <base gxb file> <snapshot files...> <outfile>\n"
			"eg. %s FrodoRL.gxb snap0 snap0.m1 snap0.m2 snap0.m3 snap0.m4 arkanoid.gxb\n",
			argv[0], argv[0]);
		exit(1);
	}

	if(stat(argv[1], &infile_s)==-1) {
		printf("error: couldn't stat %s\n", argv[1]);
		exit(1);
	}
	buf=(char *)malloc(infile_s.st_size);

	if((infile=fopen(argv[1], "r"))==NULL) {
		printf("can't open %s\n", argv[1]);
		exit(1);
	}
	fread(buf, infile_s.st_size, 1, infile);
	fclose(infile);

	image_buf=(char *)malloc(1269+65536);
	image_buf_index=0;
	for(i=2; i<7; i++) {
		if((image=fopen(argv[i], "r"))==NULL) {
			printf("error: can't open %s", argv[i]);
			exit(1);
		}
		if(i==2) {
			fread(image_buf, 1269, 1, image);
			image_buf_index+=1269;
		} else {
			fread(image_buf+image_buf_index, 16384, 1, image);
			image_buf_index+=16384;
		}
		fclose(image);
	}

	char *marker="SNAPSHOT_IMAGE_GOES_HERE_BOOYA";
	image_start=NULL;
	for(i=0; i<infile_s.st_size; i++) {
		if(!strcmp(buf+i, marker)) {
			image_start=buf+i;
			break;
		}
	}
	if(image_start==NULL) {
		printf("error finding image space in gxb file\n");
		exit(1);
	}

	memcpy(image_start, image_buf, 1269+65536);

	if((outfile=fopen(argv[7], "w"))==NULL) {
		printf("error opening %s for writing\n", argv[7]);
		exit(1);
	}
	fwrite(buf, infile_s.st_size, 1, outfile);
	fclose(outfile);

	exit(0);
}
